c     Copyright (C)
c     2008-2013 Universit Paul Sabatier
c     2008-2013 Centre National de la Recherche Scientifique
c     2008-2013 Ecole des Mines d'Albi
c     2008-2013 Universit de Bordeaux 1
c     2008-2013 Fondation STAE
c     2014-2018 Meso-Star
c     
c     This file must be used under the terms of the CeCILL license.
c     This source file is licensed as described in the file COPYING, which
c     you should have received as part of this distribution.  The terms
c     are also available at
c     http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.txt
c     
      subroutine modify_iso_index(Nmol,mol_niso,iso_index)
      implicit none
c     Purpose: to modify isotopes indexes
c     Isotopes indexes that are read from file "molparam.txt" by routine "read_molparam" are not
c     the same indexes that are used in the main HITRAN database "HITRAN04.par".
c     This routine will modify "iso_index" accordingly
c
c     Inputs:
c       + Nmol: the number of molecules used in the HITRAN database
c       + mol_niso(mol) is the number of isotopes for molecule index 'mol'
c       + iso_index(mol,iso) is the index of isotope index 'iso' of molecule index 'mol'
c                                        as read from the "molparam.txt" file
c
c     Ouput;
c       + iso_index(mol,iso) now refers to indexes used in the main HITRAN04.par database
c
      
      include './max.inc'
      integer Nmol
      integer mol_niso(1:Nmol_max)
      integer iso_index(1:Nmol_max,1:Niso_max)
      integer mol,iso

      do mol=1,Nmol
         do iso=1,mol_niso(mol)
            iso_index(mol,iso)=iso
         enddo ! iso
      enddo ! mol

      return
      end
